import { computed as b, ref as d, onMounted as Je, onBeforeUnmount as Ke, watch as Ne, openBlock as s, createElementBlock as r, normalizeClass as ie, normalizeStyle as Y, renderSlot as m, createBlock as H, createCommentVNode as v, unref as o, createSlots as Qe, withCtx as $, normalizeProps as Q, guardReactiveProps as Z, createVNode as Oe, createElementVNode as g, Fragment as w, renderList as A, toDisplayString as k, createTextVNode as Ae, nextTick as Ze, pushScopeId as et, popScopeId as tt } from "vue";
import { u as lt, o as at, e as De, g as ot, c as ut, b as st, d as Ie, p as G, m as nt, G as rt, f as P, X as it, s as ee, w as vt, j as ct, H as L, i as X, k as p, n as te, t as dt, a as ht, x as yt, q as ft, r as pt } from "./index-Bu852AzK.js";
import { t as gt, u as bt } from "./useResponsive-NZB-WLRF.js";
import { _ as mt } from "./Title-B6kWQmNb.js";
import { u as wt, U as kt } from "./usePrinter-CaNEdNUc.js";
import { D as xt } from "./DataTable-D1vDu_2B.js";
import { _ as _t } from "./Tooltip-Cwp4dS4t.js";
import { L as Ct } from "./Legend-CZk6McMv.js";
import $t from "./vue-ui-skeleton-B-obKEDg.js";
import Pt from "./vue-ui-accordion-CBwmD_zS.js";
import { u as Be } from "./useNestedProp-1sCLAHuR.js";
import { _ as Lt } from "./PackageVersion-DDKechCD.js";
import { _ as St } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ft = (U) => (et("data-v-2ebaf5df"), U = U(), tt(), U), zt = ["id"], Tt = ["xmlns", "viewBox"], Yt = { key: 0 }, Xt = ["id"], Nt = ["stop-color"], Ot = ["offset", "stop-color"], At = ["offset", "stop-color"], Dt = ["stop-color"], It = { key: 1 }, Bt = ["id", "cx", "cy"], Vt = ["stop-color", "stop-opacity"], Mt = ["stop-color"], Gt = ["id"], jt = ["id"], Ht = /* @__PURE__ */ Ft(() => /* @__PURE__ */ g("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Ut = ["id"], Et = ["flood-color"], Rt = ["d", "stroke", "filter"], Wt = ["x1", "y1", "x2", "y2", "stroke", "filter"], qt = ["cx", "cy", "r", "fill", "filter"], Jt = ["stroke", "d"], Kt = ["d", "fill", "stroke", "stroke-width", "filter"], Qt = ["stroke", "d"], Zt = ["d", "fill", "stroke", "stroke-width", "filter"], el = ["cx", "cy", "r", "stroke"], tl = ["cx", "cy", "r", "fill"], ll = ["d", "fill", "onMouseenter", "onClick"], al = ["x", "y", "fill", "font-size"], ol = ["x", "y", "fill", "font-size"], ul = ["x", "y", "fill", "font-size"], sl = ["x", "y", "fill", "font-size"], nl = ["filter"], rl = { key: 0 }, il = ["x", "y"], vl = { key: 1 }, cl = ["cx", "cy", "fill", "filter", "onClick"], dl = ["cx", "cy", "fill", "filter", "onClick"], hl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], yl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], fl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], pl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], gl = { key: 2 }, bl = ["x", "y", "width"], ml = ["x", "y", "width"], wl = {
  key: 3,
  class: "vue-data-ui-watermark"
}, kl = ["onClick"], xl = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, _l = { key: 1 }, Cl = ["innerHTML"], $l = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(U, { expose: Ve, emit: ve }) {
    const N = U, { vue_ui_donut: Me } = lt(), E = b({
      get() {
        return !!N.dataset && N.dataset.length;
      },
      set(l) {
        return l;
      }
    }), R = d(null), ce = d(null), de = d(null), le = d(null), he = d(0), ye = d(0), fe = d(0);
    Je(() => {
      pe();
    }), Ke(() => {
      le.value && le.value.disconnect();
    });
    function pe() {
      if (at(N.dataset) ? De({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : N.dataset.forEach((l, n) => {
        ot({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          E.value = !1, De({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: n
          });
        });
      }), e.value.responsive) {
        const l = gt(() => {
          const { width: n, height: t } = bt({
            chart: R.value,
            title: e.value.style.chart.title.text ? ce.value : null,
            legend: e.value.style.chart.legend.show ? de.value : null
          });
          u.value.width = n, u.value.height = t;
        });
        le.value = new ResizeObserver(l), le.value.observe(R.value.parentNode);
      }
    }
    const x = d(ut()), Ge = d(null), oe = d(!1), ue = d(""), z = d(null), ge = d(0);
    function be() {
      const l = Be({
        userConfig: N.config,
        defaultConfig: Me
      });
      return l.theme ? {
        ...Be({
          userConfig: dt.vue_ui_donut[l.theme] || N.config,
          defaultConfig: l
        }),
        customPalette: ht[l.theme] || G
      } : l;
    }
    const e = b({
      get: () => be(),
      set: (l) => l
    });
    Ne(() => N.config, (l) => {
      e.value = be(), pe(), he.value += 1, ye.value += 1, fe.value += 1;
    }, { deep: !0 });
    const { isPrinting: me, isImaging: we, generatePdf: ke, generateImage: xe } = wt({
      elementId: `donut__${x.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut"
    }), _e = b(() => st(e.value.customPalette)), h = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), u = d({
      height: 360,
      width: 512
    }), W = b(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, n = u.value.width * l, t = n > F.value ? F.value : n;
      return t < 24 ? 24 : t;
    }), B = b(() => N.dataset.map((l, n) => ({
      name: l.name,
      color: Ie(l.color) || _e.value[n] || G[n] || G[n % G.length],
      value: l.values.reduce((t, a) => t + a, 0),
      absoluteValues: l.values,
      comment: l.comment || ""
    }))), S = d(B.value);
    Ne(() => B.value, (l) => S.value = l);
    function je() {
      return B.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const O = d([]), Ce = d(null), $e = d(null), V = d(!1);
    function Pe(l) {
      const n = B.value.find((i, f) => f === l);
      let a = S.value.find((i, f) => f === l).value;
      if (O.value.includes(l)) {
        let f = function() {
          a > i ? (cancelAnimationFrame(Ce.value), S.value = S.value.map((y, re) => l === re ? {
            ...y,
            value: i
          } : y), V.value = !1) : (V.value = !0, a += i * 0.025, S.value = S.value.map((y, re) => l === re ? {
            ...y,
            value: a
          } : y), Ce.value = requestAnimationFrame(f));
        };
        O.value = O.value.filter((y) => y !== l);
        const i = n.value;
        f();
      } else if (O.value.length < B.value.length - 1) {
        let i = function() {
          a < 0.1 ? (cancelAnimationFrame($e.value), O.value.push(l), S.value = S.value.map((f, y) => l === y ? {
            ...f,
            value: 0
          } : f), V.value = !1) : (V.value = !0, a /= 1.1, S.value = S.value.map((f, y) => l === y ? {
            ...f,
            value: a
          } : f), $e.value = requestAnimationFrame(i));
        };
        i();
      }
      ve("selectLegend", D.value.map((i) => ({
        name: i.name,
        color: i.color,
        value: i.value
      })));
    }
    const D = b(() => (S.value.forEach((l, n) => {
      if ([null, void 0].includes(l.values))
        return {
          ...l,
          values: []
        };
    }), S.value.map((l, n) => ({
      ...l,
      seriesIndex: n
    })).filter((l, n) => !O.value.includes(n)))), Le = b(() => N.dataset.map((l, n) => ({
      name: l.name,
      color: Ie(l.color) || _e.value[n] || G[n] || G[n % G.length],
      value: (l.values || []).reduce((t, a) => t + a, 0),
      shape: "circle"
    })).map((l, n) => ({
      ...l,
      proportion: l.value / N.dataset.map((t) => (t.values || []).reduce((a, i) => a + i, 0)).reduce((t, a) => t + a, 0),
      opacity: O.value.includes(n) ? 0.5 : 1,
      segregate: () => Pe(n),
      isSegregated: O.value.includes(n)
    }))), He = b(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), F = b(() => {
      const l = Math.min(u.value.width / 3, u.value.height / 3);
      return l < 55 ? 55 : l;
    }), C = b(() => nt({ series: D.value }, u.value.width / 2, u.value.height / 2, F.value, F.value, 1.99999, 2, 1, 360, 105.25, W.value)), c = b(() => {
      const l = Math.max(...D.value.map((t) => t.value)), n = D.value.map((t) => t.value / l);
      return rt({
        series: n,
        center: {
          x: u.value.width / 2,
          y: u.value.height / 2
        },
        maxRadius: Math.min(u.value.width, u.value.height) / 3
      });
    });
    function j(l) {
      return l.x > u.value.width / 2 + 6 ? "start" : l.x < u.value.width / 2 - 6 ? "end" : "middle";
    }
    function Ue(l) {
      return l.middlePoint.y > u.value.height / 2 ? L({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 100, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y : L({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 0, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y - 100;
    }
    function T(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function se(l, n) {
      const t = l.value / Ee(n);
      return isNaN(t) ? 0 : X(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        P({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function Ee(l) {
      return [...l].map((n) => n.value).reduce((n, t) => n + t, 0);
    }
    const _ = b(() => D.value.map((l) => l.value).reduce((l, n) => l + n, 0)), Se = b(() => _.value / D.value.length), ne = d(null), q = d(!1);
    function Re({ datapoint: l, relativeIndex: n, seriesIndex: t, show: a = !1 }) {
      ne.value = { datapoint: l, seriesIndex: t, config: e.value, series: B.value }, oe.value = a, z.value = n;
      let i = "";
      const f = e.value.style.chart.tooltip.customFormat;
      if (q.value = !1, yt(f))
        try {
          const y = f({
            seriesIndex: t,
            datapoint: l,
            series: B.value,
            config: e.value
          });
          typeof y == "string" && (ue.value = y, q.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), q.value = !1;
        }
      if (!q.value) {
        if (i += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, i += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (i += `<b>${X(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          P({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: n,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const y = X(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            P({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: n,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? i += `<span>(${y})</span></div>` : i += `<b>${y}</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), ue.value = `<div>${i}</div>`;
      }
    }
    function J(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(z.value) && z.value !== l ? `url(#blur_${x.value})` : "";
    }
    const I = b(() => {
      const l = D.value.map((t) => ({
        name: t.name,
        color: t.color
      })), n = D.value.map((t) => t.value);
      return { head: l, body: n };
    });
    function Fe() {
      Ze(() => {
        const l = I.value.head.map((a, i) => [[
          a.name
        ], [I.value.body[i]], [isNaN(I.value.body[i] / _.value) ? "-" : I.value.body[i] / _.value * 100]]), n = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = ft(n);
        pt({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const ae = b(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        P({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: _.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], n = I.value.head.map((i, f) => {
        const y = P({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: I.value.body[f], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: i.color,
            name: i.name
          },
          y,
          isNaN(I.value.body[f] / _.value) ? "-" : (I.value.body[f] / _.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: n,
        config: t
      };
    }), K = d(!1);
    function We(l) {
      K.value = l, ge.value += 1;
    }
    const ze = b(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function qe(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((n) => "-").join("");
    }
    function M(l, n) {
      ve("selectDatapoint", { datapoint: l, index: n });
    }
    function Te() {
      h.value.showTable = !h.value.showTable;
    }
    function Ye() {
      h.value.dataLabels.show = !h.value.dataLabels.show;
    }
    function Xe() {
      h.value.showTooltip = !h.value.showTooltip;
    }
    return Ve({
      getData: je,
      generatePdf: ke,
      generateCsv: Fe,
      generateImage: xe,
      toggleTable: Te,
      toggleLabels: Ye,
      toggleTooltip: Xe
    }), (l, n) => (s(), r("div", {
      ref_key: "donutChart",
      ref: R,
      class: ie(`vue-ui-donut ${K.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Y(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${x.value}`
    }, [
      m(l.$slots, "userConfig", {}, void 0, !0),
      e.value.style.chart.title.text ? (s(), r("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: ce,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (s(), H(mt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : v("", !0),
      e.value.userOptions.show && E.value ? (s(), H(kt, {
        ref_key: "details",
        ref: Ge,
        key: `user_option_${ge.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: o(me),
        isImaging: o(we),
        uid: x.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: K.value,
        chartElement: R.value,
        position: e.value.userOptions.position,
        isTooltip: h.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        onToggleFullscreen: We,
        onGeneratePdf: o(ke),
        onGenerateCsv: Fe,
        onGenerateImage: o(xe),
        onToggleTable: Te,
        onToggleLabels: Ye,
        onToggleTooltip: Xe
      }, Qe({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: $(() => [
            m(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: $(() => [
            m(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: $(() => [
            m(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: $(() => [
            m(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: $(() => [
            m(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: $(() => [
            m(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: $(({ toggleFullscreen: t, isFullscreen: a }) => [
            m(l.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "onGeneratePdf", "onGenerateImage"])) : v("", !0),
      E.value ? (s(), r("svg", {
        key: 2,
        xmlns: o(it),
        class: ie({ "vue-data-ui-fullscreen--on": K.value, "vue-data-ui-fulscreen--off": !K.value }),
        viewBox: `0 0 ${u.value.width <= 0 ? 10 : u.value.width} ${u.value.height <= 0 ? 10 : u.value.height}`,
        style: Y(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Oe(Lt),
        e.value.type === "classic" ? (s(), r("defs", Yt, [
          e.value.style.chart.useGradient ? (s(), r("radialGradient", {
            key: 0,
            id: `gradient_${x.value}`
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": o(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Nt),
            g("stop", {
              offset: `${(1 - W.value / F.value) * 100}%`,
              "stop-color": o(ee)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, Ot),
            g("stop", {
              offset: `${(1 - W.value / F.value / 2) * 100}%`,
              "stop-color": o(ee)("#FFFFFF", e.value.style.chart.gradientIntensity)
            }, null, 8, At),
            g("stop", {
              offset: "100%",
              "stop-color": o(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Dt)
          ], 8, Xt)) : v("", !0)
        ])) : v("", !0),
        e.value.type === "polar" ? (s(), r("defs", It, [
          (s(!0), r(w, null, A(c.value, (t, a) => (s(), r("radialGradient", {
            id: `polar_gradient_${a}_${x.value}`,
            cx: t.middlePoint.x / u.value.width * 100 + "%",
            cy: t.middlePoint.y / u.value.height * 100 + "%",
            r: "62%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": o(vt)(C.value[a].color, 0.05),
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, Vt),
            g("stop", {
              offset: "100%",
              "stop-color": C.value[a].color
            }, null, 8, Mt)
          ], 8, Bt))), 256))
        ])) : v("", !0),
        g("defs", null, [
          g("filter", {
            id: `blur_${x.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            g("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${x.value}`
            }, null, 8, jt),
            Ht
          ], 8, Gt),
          g("filter", {
            id: `shadow_${x.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            g("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Et)
          ], 8, Ut)
        ]),
        e.value.type === "classic" ? (s(!0), r(w, { key: 2 }, A(C.value, (t, a) => (s(), r("g", null, [
          T(t) && h.value.dataLabels.show ? (s(), r("path", {
            key: 0,
            d: o(ct)(t, { x: u.value.width / 2, y: u.value.height / 2 }, 16, 16, !1, !1, W.value),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: J(a)
          }, null, 8, Rt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "polar" ? (s(!0), r(w, { key: 3 }, A(C.value, (t, a) => (s(), r("g", null, [
          T(t) && h.value.dataLabels.show ? (s(), r("line", {
            key: 0,
            x1: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
            y1: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
            x2: c.value[a].middlePoint.x,
            y2: c.value[a].middlePoint.y,
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: J(a)
          }, null, 8, Wt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "classic" ? (s(), r("circle", {
          key: 4,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: F.value <= 0 ? 10 : F.value,
          fill: e.value.style.chart.backgroundColor,
          filter: e.value.style.chart.layout.donut.useShadow ? `url(#shadow_${x.value})` : ""
        }, null, 8, qt)) : v("", !0),
        _.value && e.value.type === "classic" ? (s(), r(w, { key: 5 }, [
          (s(!0), r(w, null, A(C.value, (t, a) => (s(), r("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, Jt))), 256)),
          (s(!0), r(w, null, A(C.value, (t, a) => (s(), r("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: o(ee)(t.color, 80),
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: J(a)
          }, null, 8, Kt))), 256))
        ], 64)) : v("", !0),
        _.value && e.value.type === "polar" ? (s(), r(w, { key: 6 }, [
          (s(!0), r(w, null, A(C.value, (t, a) => (s(), r("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: c.value[a].path,
            fill: "#FFFFFF"
          }, null, 8, Qt))), 256)),
          (s(!0), r(w, null, A(C.value, (t, a) => (s(), r("path", {
            class: "vue-ui-donut-arc-path",
            d: c.value[a].path,
            fill: e.value.style.chart.useGradient ? `url(#polar_gradient_${a}_${x.value})` : t.color,
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: J(a)
          }, null, 8, Zt))), 256))
        ], 64)) : (s(), r("circle", {
          key: 7,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: F.value <= 0 ? 10 : F.value,
          fill: "transparent",
          stroke: e.value.style.chart.backgroundColor
        }, null, 8, el)),
        e.value.style.chart.useGradient && e.value.type === "classic" ? (s(), r("circle", {
          key: 8,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: (
            /* This might require adjustments */
            F.value <= 0 ? 10 : F.value
          ),
          fill: `url(#gradient_${x.value})`
        }, null, 8, tl)) : v("", !0),
        _.value ? (s(!0), r(w, { key: 9 }, A(C.value, (t, a) => (s(), r("path", {
          "data-cy-donut-trap": "",
          d: e.value.type === "classic" ? t.arcSlice : c.value[a].path,
          fill: z.value === a ? "rgba(0,0,0,0.1)" : "transparent",
          onMouseenter: (i) => Re({
            datapoint: t,
            relativeIndex: a,
            seriesIndex: t.seriesIndex,
            show: !0
          }),
          onMouseleave: n[0] || (n[0] = (i) => {
            oe.value = !1, z.value = null;
          }),
          onClick: (i) => M(t, a)
        }, null, 40, ll))), 256)) : v("", !0),
        e.value.type === "classic" ? (s(), r(w, { key: 10 }, [
          e.value.style.chart.layout.labels.hollow.total.show ? (s(), r("text", {
            key: 0,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
          }, k(e.value.style.chart.layout.labels.hollow.total.text), 13, al)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.total.show ? (s(), r("text", {
            key: 1,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
          }, k(o(X)(
            e.value.style.chart.layout.labels.hollow.total.value.formatter,
            _.value,
            o(P)({
              p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
              v: _.value,
              s: e.value.style.chart.layout.labels.hollow.total.value.suffix
            })
          )), 13, ol)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (s(), r("text", {
            key: 2,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
          }, k(e.value.style.chart.layout.labels.hollow.average.text), 13, ul)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (s(), r("text", {
            key: 3,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
          }, k(V.value ? "--" : o(X)(
            e.value.style.chart.layout.labels.hollow.average.value.formatter,
            Se.value,
            o(P)({
              p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
              v: Se.value,
              s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
              r: e.value.style.chart.layout.labels.hollow.average.value.rounding
            })
          )), 13, sl)) : v("", !0)
        ], 64)) : v("", !0),
        (s(!0), r(w, null, A(C.value, (t, a) => (s(), r("g", {
          filter: J(a),
          class: ie({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (s(), r("g", rl, [
            (s(), r("foreignObject", {
              x: o(p)(t, !0).anchor === "end" ? o(p)(t).x - 120 : o(p)(t, !0).anchor === "middle" ? o(p)(t).x - 60 : o(p)(t).x,
              y: o(te)(t) - (ze.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              g("div", null, [
                m(l.$slots, "dataLabel", Q(Z({
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(z.value) || z.value === a,
                  isSafari: ze.value,
                  isVisible: T(t) && h.value.dataLabels.show,
                  textAlign: o(p)(t, !0, 16, !0).anchor,
                  flexAlign: o(p)(t, !0, 16).anchor,
                  percentage: se(t, C.value)
                })), void 0, !0)
              ])
            ], 8, il))
          ])) : (s(), r("g", vl, [
            e.value.type === "classic" ? (s(), r(w, { key: 0 }, [
              T(t) && h.value.dataLabels.show ? (s(), r("circle", {
                key: 0,
                cx: o(p)(t).x,
                cy: o(te)(t) - 3.5,
                fill: t.color,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(z.value) || z.value === a ? "" : `url(#blur_${x.value})`,
                onClick: (i) => M(t, a)
              }, null, 8, cl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (s(), r(w, { key: 1 }, [
              T(t) && h.value.dataLabels.show ? (s(), r("circle", {
                key: 0,
                cx: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                cy: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
                fill: t.color,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(z.value) || z.value === a ? "" : `url(#blur_${x.value})`,
                onClick: (i) => M(t, a)
              }, null, 8, dl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "classic" ? (s(), r(w, { key: 2 }, [
              T(t) && h.value.dataLabels.show ? (s(), r("text", {
                key: 0,
                "text-anchor": o(p)(t, !0, 12).anchor,
                x: o(p)(t, !0, 12).x,
                y: o(te)(t),
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => M(t, a)
              }, k(se(t, C.value)) + " " + k(e.value.style.chart.layout.labels.value.show ? `(${o(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                o(P)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, hl)) : v("", !0),
              T(t) && h.value.dataLabels.show ? (s(), r("text", {
                key: 1,
                "text-anchor": o(p)(t).anchor,
                x: o(p)(t, !0, 12).x,
                y: o(te)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => M(t, a)
              }, k(t.name), 13, yl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (s(), r(w, { key: 3 }, [
              T(t) && h.value.dataLabels.show ? (s(), r("text", {
                key: 0,
                "text-anchor": j(c.value[a].middlePoint),
                x: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                y: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => M(t, a)
              }, k(se(t, C.value)) + " " + k(e.value.style.chart.layout.labels.value.show ? `(${o(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                o(P)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, fl)) : v("", !0),
              T(t) && h.value.dataLabels.show ? (s(), r("text", {
                key: 1,
                "text-anchor": j(c.value[a].middlePoint),
                x: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                y: o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => M(t, a)
              }, k(t.name), 13, pl)) : v("", !0)
            ], 64)) : v("", !0)
          ])),
          h.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (s(), r("g", gl, [
            T(t) && e.value.type === "classic" ? (s(), r("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (o(p)(t, !0).anchor === "end" ? o(p)(t).x - e.value.style.chart.comments.width : o(p)(t, !0).anchor === "middle" ? o(p)(t).x - e.value.style.chart.comments.width / 2 : o(p)(t).x),
              y: o(te)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              g("div", null, [
                m(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: o(p)(t, !0, 16, !0).anchor, flexAlign: o(p)(t, !0, 16).anchor }
                }, void 0, !0)
              ])
            ], 8, bl)) : v("", !0),
            T(t) && e.value.type === "polar" ? (s(), r("foreignObject", {
              key: 1,
              x: e.value.style.chart.comments.offsetX + (j(c.value[a].middlePoint) === "end" ? o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x - e.value.style.chart.comments.width : j(c.value[a].middlePoint) === "middle" ? o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x - e.value.style.chart.comments.width / 2 : o(L)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x),
              y: Ue(c.value[a]) + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              g("div", null, [
                m(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: j(c.value[a].middlePoint), flexAlign: j(c.value[a].middlePoint) }
                }, void 0, !0)
              ])
            ], 8, ml)) : v("", !0)
          ])) : v("", !0)
        ], 10, nl))), 256)),
        m(l.$slots, "svg", { svg: u.value }, void 0, !0)
      ], 14, Tt)) : v("", !0),
      l.$slots.watermark ? (s(), r("div", wl, [
        m(l.$slots, "watermark", Q(Z({ isPrinting: o(me) || o(we) })), void 0, !0)
      ])) : v("", !0),
      E.value ? v("", !0) : (s(), H($t, {
        key: 4,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: W.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      g("div", {
        ref_key: "chartLegend",
        ref: de
      }, [
        e.value.style.chart.legend.show ? (s(), H(Ct, {
          key: `legend_${fe.value}`,
          legendSet: Le.value,
          config: He.value,
          onClickMarker: n[1] || (n[1] = ({ i: t }) => Pe(t))
        }, {
          item: $(({ legend: t, index: a }) => [
            g("div", {
              onClick: (i) => t.segregate(),
              style: Y(`opacity:${O.value.includes(a) ? 0.5 : 1}`)
            }, [
              Ae(k(t.name) + ": " + k(o(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                o(P)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: a
                }
              )) + " ", 1),
              O.value.includes(a) ? (s(), r("span", _l, " ( " + k(qe(t.proportion * 100)) + " % ) ", 1)) : (s(), r("span", xl, " (" + k(isNaN(t.value / _.value) ? "-" : o(X)(
                e.value.style.chart.layout.labels.percentage.formatter,
                V.value ? t.proportion * 100 : t.value / _.value * 100,
                o(P)({
                  v: V.value ? t.proportion * 100 : t.value / _.value * 100,
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, kl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : v("", !0),
        m(l.$slots, "legend", { legend: Le.value }, void 0, !0)
      ], 512),
      Oe(_t, {
        show: h.value.showTooltip && oe.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: R.value,
        content: ue.value,
        isCustom: q.value
      }, {
        "tooltip-before": $(() => [
          m(l.$slots, "tooltip-before", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        "tooltip-after": $(() => [
          m(l.$slots, "tooltip-after", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      E.value ? (s(), H(Pt, {
        key: 5,
        hideDetails: "",
        config: {
          open: h.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: $(() => [
          (s(), H(xt, {
            key: `table_${ye.value}`,
            colNames: ae.value.colNames,
            head: ae.value.head,
            body: ae.value.body,
            config: ae.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: n[2] || (n[2] = (t) => h.value.showTable = !1)
          }, {
            th: $(({ th: t }) => [
              g("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Cl)
            ]),
            td: $(({ td: t }) => [
              Ae(k(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? t : o(X)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                o(P)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : o(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                o(P)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 14, zt));
  }
}, Bl = /* @__PURE__ */ St($l, [["__scopeId", "data-v-2ebaf5df"]]);
export {
  Bl as default
};
